Index: /main/trunk/gli/src/org/greenstone/gatherer/util/SafeProcess.java
===================================================================
--- /main/trunk/gli/src/org/greenstone/gatherer/util/SafeProcess.java	(revision 31663)
+++ /main/trunk/gli/src/org/greenstone/gatherer/util/SafeProcess.java	(revision 31664)
@@ -54,5 +54,5 @@
     private String inputStr = null;
     private Process process = null;
-	private boolean forciblyTerminateProcess = false;
+    private boolean forciblyTerminateProcess = false;
 	
     // output from running SafeProcess.runProcess()
@@ -135,12 +135,12 @@
 	    
 	    // http://stackoverflow.com/questions/5283444/convert-array-of-strings-into-a-string-in-java
-		//log("SafeProcess running:" + Arrays.toString(command_args));
-		StringBuffer cmdDisplay = new StringBuffer();
-		for(int i = 0; i < command_args.length; i++) {
-			cmdDisplay.append(" ").append(command_args[i]);
-		}
-		log("SafeProcess running: [" + cmdDisplay + "]");
-		cmdDisplay = null; // let the GC have it    
-		
+	    //log("SafeProcess running:" + Arrays.toString(command_args));
+	    StringBuffer cmdDisplay = new StringBuffer();
+	    for(int i = 0; i < command_args.length; i++) {
+		cmdDisplay.append(" ").append(command_args[i]);
+	    }
+	    log("SafeProcess running: [" + cmdDisplay + "]");
+	    cmdDisplay = null; // let the GC have it    
+	    
 	    
 	    if(this.envp == null) { 
@@ -157,5 +157,5 @@
 		}
 	    }
-	}	
+	}
 
 	return prcs;
@@ -167,5 +167,5 @@
 				   SafeProcess.InputStreamGobbler errorGobbler)
 	throws IOException, InterruptedException
-    {	
+    {
 	// kick off the stream gobblers
 	inputGobbler.start();
@@ -203,9 +203,9 @@
 	    errorGobbler.interrupt();
 	    outputGobbler.interrupt();
-		
-		// Since we have been cancelled (InterruptedException), or on any Exception, we need
-		// to forcibly terminate process eventually after the finally code first waits for each worker thread
-		// to die off. Don't set process=null until after we've forcibly terminated it if needs be.
-		this.forciblyTerminateProcess = true; 
+	    
+	    // Since we have been cancelled (InterruptedException), or on any Exception, we need
+	    // to forcibly terminate process eventually after the finally code first waits for each worker thread
+	    // to die off. Don't set process=null until after we've forcibly terminated it if needs be.
+	    this.forciblyTerminateProcess = true; 
 		
 	    // even after the interrupts, we want to proceed to calling join() on all the worker threads
@@ -252,12 +252,12 @@
     // Run a very basic process: with no reading from or writing to the Process' iostreams,
     // this just execs the process and waits for it to return.
-	// Don't call this method but the zero-argument runProcess() instead if your process will
-	// output stuff to its stderr and stdout streams but you don't need to monitory these.
-	// Because, as per a comment in GLI's GS3ServerThread.java,
-	// in Java 6, it wil block if you don't handle a process' streams when the process is
-	// outputting something. (Java 7+ won't block if you don't bother to handle the output streams)
+    // Don't call this method but the zero-argument runProcess() instead if your process will
+    // output stuff to its stderr and stdout streams but you don't need to monitory these.
+    // Because, as per a comment in GLI's GS3ServerThread.java,
+    // in Java 6, it wil block if you don't handle a process' streams when the process is
+    // outputting something. (Java 7+ won't block if you don't bother to handle the output streams)
     public int runBasicProcess() {
 	try {
-		this.forciblyTerminateProcess = true;
+	    this.forciblyTerminateProcess = true;
 		
 	    // 1. create the process
@@ -266,5 +266,5 @@
 	    this.exitValue = process.waitFor();
 
-		this.forciblyTerminateProcess = false;
+	    this.forciblyTerminateProcess = false;
 	} catch(IOException ioe) {		
 		
@@ -275,5 +275,5 @@
 	    }
 	} catch(InterruptedException ie) {
-		
+
 	    if(exceptionHandler != null) {
 		exceptionHandler.gotException(ie);
@@ -288,6 +288,6 @@
 		destroyProcess(process); // see runProcess() below		
 	    }
-		process = null;
-		this.forciblyTerminateProcess = false; // reset
+	    process = null;
+	    this.forciblyTerminateProcess = false; // reset
 	}
 	return this.exitValue;
@@ -311,5 +311,5 @@
 
 	try {
-		this.forciblyTerminateProcess = false;
+	    this.forciblyTerminateProcess = false;
 		
 	    // 1. get the Process object
@@ -351,5 +351,5 @@
        
 	} catch(IOException ioe) {
-		this.forciblyTerminateProcess = true;
+	    this.forciblyTerminateProcess = true;
 
 	    if(exceptionHandler != null) {
@@ -381,5 +381,5 @@
 	    }
 	    process = null;
-		this.forciblyTerminateProcess = false; // reset
+	    this.forciblyTerminateProcess = false; // reset
 	}
 	
@@ -394,5 +394,5 @@
 
 	try {
-		this.forciblyTerminateProcess = false;
+	    this.forciblyTerminateProcess = false;
 		
 	    // 1. get the Process object
@@ -428,5 +428,5 @@
        
 	} catch(IOException ioe) {
-		this.forciblyTerminateProcess = true;
+	    this.forciblyTerminateProcess = true;
 		
 	    if(exceptionHandler != null) {
@@ -468,6 +468,6 @@
 		log("*** Have called process.destroy 1");
 	    }
-		process = null;
-		this.forciblyTerminateProcess = false; //reset		
+	    process = null;
+	    this.forciblyTerminateProcess = false; //reset		
 	}
 	
@@ -839,5 +839,5 @@
     
     public InputStreamGobbler(InputStream is, boolean split_newlines)
-    {	
+    {
 	this(); // sets thread name
 	this.is = is;